%{!?dnf_lowest_compatible: %global dnf_lowest_compatible 4.2.19}
%global dnf_plugins_extra_obsolete 2.0.0

# YUM v3 has been removed from Mageia 8 onward
%if 0%{?mageia} && 0%{?mageia} < 8
%bcond_with as_yum
%else
%bcond_without as_yum
%endif

%if %{with as_yum}
# yum-utils features obsoleted by DNF itself...
%global yum_replaces() \
Obsoletes:  %{1} < 4.0.0 \
Provides:   %{1} = %{version}-%{release} \
%{nil}
%endif

Name:           dnf-plugins-extras
Version:        4.0.13
Release:        %mkrel 1
Summary:        Extras Plugins for DNF
Group:          System/Packaging
License:        GPLv2+
URL:            https://github.com/rpm-software-management/%{name}
Source0:        %{url}/archive/%{version}/%{name}-%{version}.tar.gz

# Backports from upstream

BuildArch:      noarch
BuildRequires:  cmake
BuildRequires:  gettext
BuildRequires:  pkgconfig(systemd)
BuildRequires:  systemd
BuildRequires:  python3-devel
BuildRequires:  python3-dnf >= %{dnf_lowest_compatible}
BuildRequires:  python3-nose
BuildRequires:  python3-sphinx
BuildRequires:  python3-kickstart
BuildRequires:  python3-systemd

%description
Extras Plugins for DNF.

%package -n python3-%{name}-common
Summary:        Common files for Extras Plugins for DNF
Group:          System/Packaging
Requires:       python3-dnf >= %{dnf_lowest_compatible}
Provides:       %{name}-common = %{version}-%{release}
Obsoletes:      %{name}-common < %{version}-%{release}
Obsoletes:      python3-%{name}-common < %{version}-%{release}
Obsoletes:      %{name} < %{version}-%{release}
Obsoletes:      %{name}-common-data < %{version}-%{release}
Conflicts:      python2-%{name}-common < %{version}-%{release}
# Python 2 bindings are no longer available
Obsoletes:      python2-%{name}-common < 4.0.1

%description -n python3-%{name}-common
Common files for Extras Plugins for DNF, Python 3 version.

%package -n python3-dnf-plugin-kickstart
Summary:        Kickstart Plugin for DNF
Group:          System/Packaging
Requires:       python3-%{name}-common = %{version}-%{release}
BuildRequires:  python3-kickstart
Requires:       python3-kickstart
Provides:       dnf-command(kickstart)
Provides:       %{name}-kickstart = %{version}-%{release}
Provides:       dnf-plugin-kickstart = %{version}-%{release}
Provides:       python3-%{name}-kickstart = %{version}-%{release}
Conflicts:      python2-dnf-plugin-kickstart < %{version}-%{release}
Obsoletes:      python3-%{name}-kickstart < %{dnf_plugins_extra_obsolete}
# Python 2 version is no longer available
Obsoletes:      python2-dnf-plugin-kickstart < 4.0.1
Obsoletes:      python2-%{name}-kickstart < %{dnf_plugins_extra_obsolete}

%description -n python3-dnf-plugin-kickstart
Kickstart Plugin for DNF, Python 3 version. Install packages listed in a
Kickstart file.

%package -n python3-dnf-plugin-rpmconf
Summary:        RpmConf Plugin for DNF
Group:          System/Packaging
BuildRequires:  python3-rpmconf
Requires:       python3-%{name}-common = %{version}-%{release}
Requires:       python3-rpmconf
Provides:       %{name}-rpmconf = %{version}-%{release}
Provides:       dnf-plugin-rpmconf = %{version}-%{release}
Provides:       python3-%{name}-rpmconf = %{version}-%{release}
Obsoletes:      python3-%{name}-rpmconf < %{dnf_plugins_extra_obsolete}
%if %{with as_yum}
%yum_replaces   yum-plugin-merge-conf
%endif

%description -n python3-dnf-plugin-rpmconf
RpmConf Plugin for DNF, Python 3 version. Handles .rpmnew, .rpmsave every
transaction.

%package -n python3-dnf-plugin-snapper
Summary:        Snapper Plugin for DNF
Group:          System/Packaging
Requires:       python3-%{name}-common = %{version}-%{release}
Requires:       python3-dbus
Requires:       snapper
Provides:       %{name}-snapper = %{version}-%{release}
Provides:       dnf-plugin-snapper = %{version}-%{release}
Provides:       python3-%{name}-snapper = %{version}-%{release}
Conflicts:      python2-dnf-plugin-snapper < %{version}-%{release}
Obsoletes:      python3-%{name}-snapper < %{dnf_plugins_extra_obsolete}
# Python 2 version is no longer available
Obsoletes:      python2-dnf-plugin-snapper < 4.0.1
Obsoletes:      python2-%{name}-snapper < %{dnf_plugins_extra_obsolete}
%if %{with as_yum}
%yum_replaces   yum-plugin-fs-snapshot
%endif

%description -n python3-dnf-plugin-snapper
Snapper Plugin for DNF, Python 3 version. Creates snapshot every transaction.

%package -n python3-dnf-plugin-system-upgrade
Summary:        System Upgrade Plugin for DNF
Group:          System/Packaging
Requires:       python3-%{name}-common = %{version}-%{release}
Requires:       python3-systemd
Provides:       dnf-command(offline-distrosync)
Provides:       dnf-command(offline-upgrade)
Provides:       dnf-command(system-upgrade)
Provides:       %{name}-system-upgrade = %{version}-%{release}
Provides:       system-upgrade = %{version}-%{release}
Provides:       dnf-plugin-system-upgrade = %{version}-%{release}
Provides:       python3-%{name}-system-upgrade = %{version}-%{release}
Obsoletes:      python3-%{name}-system-upgrade < %{dnf_plugins_extra_obsolete}
Obsoletes:      fedup < 0.9.4
Obsoletes:      dnf-plugin-system-upgrade < 0.10
Conflicts:      python2-dnf-plugin-system-upgrade < %{version}-%{release}
# Python 2 version is no longer available
Obsoletes:      python2-dnf-plugin-system-upgrade < 4.0.1
Obsoletes:      python2-%{name}-system-upgrade < 4.0.1
BuildRequires:  pkgconfig(systemd)
BuildRequires:  systemd
BuildRequires:  python3-systemd
%{?systemd_requires}
%if %{with as_yum}
%yum_replaces   yum-plugin-upgrade-helper
%endif

%description -n python3-dnf-plugin-system-upgrade
System Upgrade Plugin for DNF, Python 3 version. Enables offline system upgrades
using the "dnf system-upgrade" command.

%package -n python3-dnf-plugin-tracer
Summary:        Tracer Plugin for DNF
Group:          System/Packaging
Requires:       python3-%{name}-common = %{version}-%{release}
Requires:       python3-tracer >= 0.6.12
Provides:       dnf-plugin-tracer = %{version}-%{release}
Provides:       %{name}-tracer = %{version}-%{release}
Provides:       python3-%{name}-tracer = %{version}-%{release}
Conflicts:      python2-dnf-plugin-tracer < %{version}-%{release}
Obsoletes:      python3-%{name}-tracer < %{dnf_plugins_extra_obsolete}
# Python 2 version is no longer available
Obsoletes:      python2-dnf-plugin-tracer < 4.0.1
Obsoletes:      python2-%{name}-tracer < %{dnf_plugins_extra_obsolete}
%if %{with as_yum}
%yum_replaces   yum-plugin-ps
%endif

%description -n python3-dnf-plugin-tracer
Tracer Plugin for DNF, Python 3 version. Finds outdated running applications in
your system every transaction.

%package -n python3-dnf-plugin-torproxy
Summary:        Tor Proxy Plugin for DNF
Group:          System/Packaging
Requires:       python3-%{name}-common = %{version}-%{release}
Requires:       python3-pycurl
Provides:       dnf-plugin-torproxy = %{version}-%{release}
Provides:       %{name}-torproxy = %{version}-%{release}
Provides:       python3-%{name}-torproxy = %{version}-%{release}
Obsoletes:      python3-%{name}-torproxy < %{dnf_plugins_extra_obsolete}

%description -n python3-dnf-plugin-torproxy
Tor proxy plugin forces DNF to use Tor to download packages. It makes sure that
Tor is working and avoids leaking the hostname by using the proper SOCKS5 interface.

%package -n python3-dnf-plugin-showvars
Summary:        showvars Plugin for DNF
Group:          System/Packaging
Requires:       python3-%{name}-common = %{version}-%{release}
Provides:       dnf-plugin-showvars = %{version}-%{release}
Provides:       python3-%{name}-showvars = %{version}-%{release}

%description -n python3-dnf-plugin-showvars
This plugin dumps the current value of any defined DNF variables.  For example
$releasever and $basearch.

%prep
%autosetup -n %{name}-%{version}%{?prerel:-%{prerel}} -p1

%build
%cmake -DPYTHON_DESIRED:FILEPATH=%{__python3}
%cmake_build
%cmake_build -t doc-man

%install
%cmake_install

mkdir -p %{buildroot}%{_unitdir}/system-update.target.wants/
pushd %{buildroot}%{_unitdir}/system-update.target.wants/
  ln -sr ../dnf-system-upgrade.service
popd

%find_lang %{name}

# no python2-torproxy
rm -rf %{buildroot}%{python2_sitelib}/dnf-plugins/torproxy.*

# Do byte-compilation for plugins (for some reason, this isn't happening automatically...?)
%py_byte_compile %{__python3} %{buildroot}%{python3_sitelib}/dnf-plugins


%check
PYTHONPATH="%{buildroot}%{python3_sitelib}:%{buildroot}%{python3_sitelib}/dnf-plugins/" nosetests-%{python3_version} -s tests/

%files -n python3-%{name}-common -f %{name}.lang
%{python3_sitelib}/dnfpluginsextras/
%dir %{python3_sitelib}/dnf-plugins/__pycache__/
%license COPYING
%doc AUTHORS README.rst

%files -n python3-dnf-plugin-kickstart
%{python3_sitelib}/dnf-plugins/kickstart.*
%{python3_sitelib}/dnf-plugins/__pycache__/kickstart.*
%{_mandir}/man8/dnf-kickstart.*

%files -n python3-dnf-plugin-rpmconf
%config(noreplace) %{_sysconfdir}/dnf/plugins/rpmconf.conf
%{python3_sitelib}/dnf-plugins/rpm_conf.*
%{python3_sitelib}/dnf-plugins/__pycache__/rpm_conf.*
%{_mandir}/man8/dnf-rpmconf.*

%files -n python3-dnf-plugin-snapper
%{python3_sitelib}/dnf-plugins/snapper.*
%{python3_sitelib}/dnf-plugins/__pycache__/snapper.*
%{_mandir}/man8/dnf-snapper.*

%files -n python3-dnf-plugin-system-upgrade
%{_unitdir}/dnf-system-upgrade.service
%{_unitdir}/dnf-system-upgrade-cleanup.service
%{_unitdir}/system-update.target.wants/dnf-system-upgrade.service
%{python3_sitelib}/dnf-plugins/system_upgrade.py
%{python3_sitelib}/dnf-plugins/__pycache__/system_upgrade.*
%{_mandir}/man8/dnf-system-upgrade.*

%files -n python3-dnf-plugin-tracer
%{python3_sitelib}/dnf-plugins/tracer.*
%{python3_sitelib}/dnf-plugins/__pycache__/tracer.*
%{_mandir}/man8/dnf-tracer.*

%files -n python3-dnf-plugin-torproxy
%config(noreplace) %{_sysconfdir}/dnf/plugins/torproxy.conf
%{python3_sitelib}/dnf-plugins/torproxy.*
%{python3_sitelib}/dnf-plugins/__pycache__/torproxy.*
%{_mandir}/man8/dnf-torproxy.*

%files -n python3-dnf-plugin-showvars
%{python3_sitelib}/dnf-plugins/showvars.*
%{python3_sitelib}/dnf-plugins/__pycache__/showvars.*
%{_mandir}/man8/dnf-showvars.*



%changelog
* Sun Dec 06 2020 ngompa <ngompa> 4.0.13-1.mga8
+ Revision: 1653891
- Update to 4.0.13

* Fri Oct 23 2020 akien <akien> 4.0.10-2.mga8
+ Revision: 1638843
- Fix build with new %%cmake_build macro

* Tue Jul 07 2020 ngompa <ngompa> 4.0.10-1.mga8
+ Revision: 1602753
- Update to 4.0.10

* Thu Feb 27 2020 ngompa <ngompa> 4.0.9-1.mga8
+ Revision: 1551014
- Update to 4.0.9
- Drop patch included in this release

* Tue Feb 18 2020 umeabot <umeabot> 4.0.8-2.mga8
+ Revision: 1539498
- Mageia 8 Mass Rebuild
+ wally <wally>
- build with new cmake macros

* Sun Dec 08 2019 ngompa <ngompa> 4.0.8-1.mga8
+ Revision: 1465232
- Update to 4.0.8
- Replace yum-utils plugins with dnf-plugins-extras

* Wed Sep 25 2019 wally <wally> 4.0.4-2.mga8
+ Revision: 1445882
- rebuild for python3.8

* Mon Apr 01 2019 ngompa <ngompa> 4.0.4-1.mga7
+ Revision: 1384553
- Update to 4.0.4
- Drop upstreamed patch

* Mon Jan 07 2019 ngompa <ngompa> 4.0.1-1.mga7
+ Revision: 1350486
- Update to 4.0.1
- Add patch to fix building man pages
- Drop Python 2 subpackages

* Sat Jan 05 2019 wally <wally> 3.0.2-3.mga7
+ Revision: 1349829
- rebuild for python3.7

* Tue Oct 16 2018 ngompa <ngompa> 3.0.2-2.mga7
+ Revision: 1320751
- Drop unnecessary dnf incompat BuildReqs/Reqs
+ pterjan <pterjan>
- Fix tests with new python-dnf by updating to 3.0.2
+ umeabot <umeabot>
- Mageia 7 Mass Rebuild
- Mageia 7 Mass Rebuild

* Sat Aug 04 2018 ngompa <ngompa> 3.0.1-1.mga7
+ Revision: 1247378
- Update to 3.0.1

* Sat Jun 30 2018 ngompa <ngompa> 3.0.0-1.mga7
+ Revision: 1240950
- Update to 3.0.0

* Wed Oct 25 2017 ngompa <ngompa> 2.0.3-1.mga7
+ Revision: 1173683
- Upgrade to 2.0.3

* Sun Aug 13 2017 ngompa <ngompa> 2.0.2-1.mga7
+ Revision: 1140111
- Upgrade to 2.0.2
- Drop backported patches

* Sat Aug 05 2017 pterjan <pterjan> 2.0.1-3.mga7
+ Revision: 1135245
- Rebuild for python 3.6

* Sat Jul 29 2017 ngompa <ngompa> 2.0.1-2.mga7
+ Revision: 1132584
- Backport from upstream to make snapper plugin take snapshots before and after rpm transactions (rhbz#1248806)

* Tue May 23 2017 ngompa <ngompa> 2.0.1-1.mga6
+ Revision: 1104149
- Upgrade to 2.0.1

* Sun May 14 2017 ngompa <ngompa> 2.0.0-2.mga6
+ Revision: 1100990
- Fix Requires for python2-dnf-plugin-system-upgrade

* Sat May 06 2017 ngompa <ngompa> 2.0.0-1.mga6
+ Revision: 1099368
- Upgrade to v2.0.0

* Fri Feb 17 2017 ngompa <ngompa> 0.10.0-1.mga6
+ Revision: 1086553
- Update to final 0.10.0 version

* Tue Nov 29 2016 ngompa <ngompa> 0.10.0-0.3.rc1.mga6
+ Revision: 1070936
- Fix torproxy plugin pycurl dependency

* Sun Nov 27 2016 ngompa <ngompa> 0.10.0-0.2.rc1.mga6
+ Revision: 1070522
- Bump for rebuilding against core/release

* Sat Nov 26 2016 ngompa <ngompa> 0.10.0-0.1.rc1.mga6
+ Revision: 1070242
- Upgrade to 0.10.0rc1
- dnf-plugin-system-upgrade is now dnf-plugin-extras-system-upgrade

* Tue May 31 2016 ngompa <ngompa> 0.0.12-3.mga6
+ Revision: 1019604
- Add patch to fix unit tests with dnf-1.1.9

* Sun Jan 24 2016 ngompa <ngompa> 0.0.12-2.mga6
+ Revision: 926836
- Import dnf-plugins-extras into Mageia

